package com.simuwang.daq.components;

import cn.hutool.core.collection.ListUtil;
import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import com.alibaba.excel.read.metadata.holder.ReadSheetHolder;
import com.simuwang.base.pojo.dto.report.SimpleTable;

import java.util.LinkedHashMap;
import java.util.List;

/**
 * @author wangzaijun
 * @date 2024/10/12 9:17
 * @description 自定义的excel多sheet解析事件监听器
 */
public class CustomExcelMultiSheetListener extends AnalysisEventListener<LinkedHashMap<String, Object>> {
    private final List<SimpleTable> tables = ListUtil.list(false);
    private SimpleTable table;

    public List<SimpleTable> getTables() {
        return tables;
    }

    public void cleanTables() {
        this.tables.clear();
    }

    @Override
    public void invoke(LinkedHashMap<String, Object> row, AnalysisContext analysisContext) {
        ReadSheetHolder sheetHolder = analysisContext.readSheetHolder();
        String sheetName = sheetHolder.getSheetName();
        if (sheetName.contains("封面") && sheetHolder.getSheetNo() == 0) {
            return;
        }
        @SuppressWarnings("unchecked")
        List<String> tableTitles = (List<String>) analysisContext.getCustom();
        String title = ReportParseUtils.cleaningValue(row.get("1"));
        if (tableTitles.contains(title)) {
            this.table = new SimpleTable(title);
            this.tables.add(table);
        }

        List<String> tableRow = ListUtil.list(true);
        for (int i = 1; i < row.size(); i++) {
            tableRow.add(ReportParseUtils.cleaningValue(row.get(String.valueOf(i))));
        }
        this.table.addRow(tableRow);
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext analysisContext) {

    }
}
